/**
 * \file hb_assert.h
 * \author Constantine  <@.com>
 * \brief Assert implementation
 *
 * \see Glossary: https://goo.gl/clvjvI
 * \copyright Copyright (c) 2016 by  LLC. All Rights Reserved.
 */


#ifndef HB_ASSERT_
#define HB_ASSERT_

#ifdef assert
#undef assert
#endif

#ifdef ENABLE_HB_ASSERT
#define str(s) #s
#define interp(s) str(s)
#define hb_assert_msg(cond, msg) "Assert: " str(cond) "; " msg "; See: " __FILE__ ":" interp(__LINE__)
#define assert_msg(x, msg) if (!(x)) assert_handler(hb_assert_msg(str(x),msg))
#define assert(x) assert_msg(x, "no description")

void assert_handler(const char* p_msg);

#else // ENABLE_HB_ASSERT

#define assert(x)

#endif // ENABLE_HB_ASSERT

#endif /* HB_ASSERT_ */