#ifndef __HB_UNIT_TESTS__
#define __HB_UNIT_TESTS__

#include "os_dependency.h"
//#include "Model/hb_model_api.h"  // HB_MODULE_INFO, HB_USER_DATA
typedef struct hb_module_info_
{
    /* descriptor of a run-time data structure */
    uint32_t token;               // module unique identifier
    uint8_t  version_major;       //
    uint8_t  version_minor;       //
    uint16_t reserved;
    uint32_t size;                // size of module vars/context (INCLUDING sizeof(HB_MODULE_INFO))
    uint16_t module_data_crc16;   // CRC16 of module vars/context, NOT including HB_MODULE_INFO (CRC16)
    uint16_t module_info_crc16;   // CRC16 of the HB_MODULE_INFO, NOT including this field
    // AK TODO: add a pointer to the module name?

} HB_MODULE_INFO;
typedef struct hb_user_data_ HB_USER_DATA;



extern volatile uint32_t unittest_ms_ticker;

typedef uint32_t (*test_case_func_t)(void);

void run_unit_tests(void);
uint32_t run_test_case(const char*pTestCaseName, test_case_func_t pTestCaseFunc);

void print_module_name(const char* pModuleName);
void print_module_info(const char* pModuleName, HB_MODULE_INFO* pInfo);
void print_test_result(char* pTestCaseName, uint32_t status);
void print_status(uint32_t status);

void unit_test_ms_ticker(uint32_t ms_ticker);;


uint32_t hb_test_core_init(HB_USER_DATA* pUserData, HB_TIME utc_tstamp, HB_TIME timezone_offset);
void     hb_test_core_uninit(void);
uint32_t hb_test_core_emulate_power_cycle(void);

#endif // __HB_UNIT_TESTS__
